;           
;        PIC12F629
;       ,    :
;             1 -          
;             2 -      1       
;                                   .
; 	MPLAB  V7.20
	list	P=PIC12F629		
 
#include <P12F629.INC>

 
;  
OZU1       	     		equ    	21h ; 
COUNTER		 	equ    	22h



; :

;7	-GP0-   
;6 	-GP1-    
;5 	-GP2-      
;4 	-GP3-  
;3 	-GP4-     ("1")
;2 	-GP5-     ("1")
;1      -VDD - +5V
;8      -VSS - GND

;           PIC-
		org 0
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;		      

	BCF STATUS,RP0;  0
	CLRF GPIO
	MOVLW b'00000111'
	MOVWF CMCON;   
	BSF STATUS,RP0 ;  1
	MOVLW b'00111100'
	MOVWF TRISIO;tris GPIO ; 0-1   GPIO     ,    2 -   
								;  3    
	BCF OPTION_REG,7 ;    
	MOVLW b'00000100';    GP2
	MOVWF WPU;
	BCF STATUS,RP0;  0
 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;     -    -    
	CALL  SIGNAL; 
	CALL  DELAY;
	CALL  SIGNAL; 
	CALL  DELAY;
ST:
	CLRWDT
	BTFSS   GPIO,2;     
	GOTO MOD1 ;    OFF
	GOTO MOD2 ;    ON

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;     1 (      )
MOD1:

	BTFSC   GPIO,4;      
	GOTO  MOD1_1
	GOTO  MOD1_2	 
	
;--------------------------------------	 

MOD1_1:
;   ,         (    ,   ).
;     
	CALL  DELAY;
	CALL  DELAY;
	GOTO  ST; 
;--------------------------------------
 MOD1_2:	  
;   ,   ,  ,      
	CALL  SIGNAL; 
	CALL  DELAY;
	GOTO  ST; 
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;      2  (           )
MOD2:
	BTFSC   GPIO,5;      . 
	GOTO  MOD2_1
	GOTO  MOD2_2	  
MOD2_1:
;     
	BTFSS   GPIO,4;      
	GOTO  MOD2_1_1
	GOTO  MOD2_1_2
	
	
MOD2_1_1:
;  ,  ,           
	CALL   SIGNAL;
	CALL  DELAY;
	GOTO  ST;
MOD2_1_2:	
;  ,  ,        
	CALL  DELAY;
	CALL  DELAY;
	GOTO  ST;
;--------------------------------------
MOD2_2:	  
;    ,    ,           
	CALL   SIGNAL;
	CALL  DELAY;
	GOTO  ST;
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;

;	GOTO  ST
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
;        
TAKT:
	CLRWDT
	MOVLW	.155;.41
           	MOVWF OZU1
TAKT_1:  DECFSZ OZU1,1
	 GOTO TAKT_1
               RETURN

;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
SIGNAL:
	CLRF  COUNTER
SIGNAL_1:
	INCF  COUNTER,1
	BTFSC  STATUS,Z
	RETURN
	BSF  GPIO,0
	NOP
	BCF  GPIO,1
	CALL TAKT
	BCF  GPIO,0
	NOP
	BSF  GPIO,1
	CALL TAKT
	GOTO SIGNAL_1	
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
DELAY:

	CLRF  COUNTER
DELAY_1:
	INCF  COUNTER,1
	BTFSC  STATUS,Z
	RETURN
	NOP
	NOP
	NOP
	CALL TAKT
	NOP
	NOP
	NOP
	CALL TAKT
	GOTO DELAY_1	

	RETURN
;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
	
	

			ORG 0X00002007   ;      , ;   
			DW  0X3F0C



	END
